import requests
import re
import json
import time
import urllib3
from urllib.parse import urlparse

urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)


# ============================================================
# 🔗 Facebook: https://www.facebook.com/itvanhai.dev9x
# 📝 Blog: https://army2.net
# 🤖 Mã nguồn này có sự hỗ trợ từ AI trong quá trình phát triển.
# ⚠️ Nếu bạn sử dụng cho mục đích thương mại, vui lòng giữ nguyên phần ghi chú này để tôn trọng tác giả.
# ============================================================

class FacebookReactionAnalyzer:
    def __init__(self, post_url):
        self.session = requests.Session()
        self.session.verify = False
        self.post_url = post_url
        self.lsd_token = None
        self.jazoest = None
        self.reactions = {
            "Like": "1635855486666999",
            "Love": "1678524932434102", 
            "Haha": "115940658764963",
            "Sad": "908563459236466",
            "Care": "613557422527858",
            "Wow": "478547315650144",
            "Angry": "444813342392137"
        }
        self.headers = {
            'User-Agent': "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/136.0.0.0 Safari/537.36",
            'Accept': "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7",
            'cache-control': "max-age=0",
            'dpr': "1",
            'sec-ch-ua': '"Chromium";v="136", "Google Chrome";v="136", "Not.A/Brand";v="99"',
            'sec-ch-ua-mobile': "?0",
            'sec-ch-ua-platform': '"Windows"',
            'sec-ch-ua-platform-version': '"19.0.0"',
            'sec-ch-ua-model': '""',
            'sec-ch-ua-full-version-list': '"Chromium";v="136.0.7103.114", "Google Chrome";v="136.0.7103.114", "Not.A/Brand";v="99.0.0.0"',
            'sec-ch-prefers-color-scheme': "dark",
            'upgrade-insecure-requests': "1",
            'sec-fetch-site': "same-origin",
            'sec-fetch-mode': "navigate",
            'sec-fetch-user': "?1",
            'sec-fetch-dest': "document",
            'accept-language': "vi-VN,vi;q=0.9",
            'priority': "u=0, i"
        }
        self.feedback_target_id = self._extract_feedback_target_id()
    
    def _extract_feedback_target_id(self):
        parts = self.post_url.split('/')
        
        # Tìm pfbid trong URL
        for part in parts:
            if part.startswith('pfbid'):
                return part
        
        # Nếu không có pfbid, lấy HTML để tìm feedback_target_id
        try:
            response = self.session.get(self.post_url, headers=self.headers)
            html_content = response.text
            
            # Tìm feedback_target_id trong HTML với nhiều patterns khác nhau
            patterns = [
                r'"feedback_target_id":"([^"]+)"',
                r'"feedbackTargetID":"([^"]+)"',
                r'"target_id":"([^"]+)"',
                r'"post_id":"([^"]+)"',
                r'feedbackTargetID["\s]*:["\s]*"([^"]+)"',
                r'feedback_target_id["\s]*:["\s]*"([^"]+)"',
                r'"feedback":[^}]*"target_id":"([^"]+)"',
                r'pfbid[A-Za-z0-9_-]+',
                r'"videoID":"(\d+)"',
                r'"video_id":"(\d+)"',
                r'"legacyID":"(\d+)"'
            ]
            
            for pattern in patterns:
                matches = re.findall(pattern, html_content)
                if matches:
                    # Lọc bỏ các ID quá ngắn hoặc không hợp lệ
                    for match in matches:
                        if len(match) > 5:
                            return match
            
            # Nếu vẫn không tìm thấy, thử lấy video ID từ URL
            video_match = re.search(r'/videos/(\d+)', self.post_url)
            if video_match:
                return video_match.group(1)
                
        except Exception as e:
            print(f"Error extracting from HTML: {e}")
        
        return None
    
    def _initialize_tokens(self):
        response = self.session.get(self.post_url, headers=self.headers)
        
        lsd_match = re.search(r'"LSD"[^{]*{"token":"([^"]+)"', response.text)
        self.lsd_token = lsd_match.group(1) if lsd_match else None
        
        jazoest_match = re.search(r'"jazoest":{"name":"jazoest","value":"([^"]+)"}', response.text)
        self.jazoest = jazoest_match.group(1) if jazoest_match else None
    
    def _get_reaction_data(self, reaction_id):
        api_url = "https://www.facebook.com/api/graphql/"
        
        payload = {
            'av': "0",
            '__aaid': "0", 
            '__user': "0",
            '__a': "1",
            '__req': "n",
            '__hs': "20234.HYP:comet_loggedout_pkg.2.1...0",
            'dpr': "1",
            '__ccg': "GOOD",
            '__rev': "1023183597",
            '__s': "jmehfj:ejwx64:a718cb",
            '__hsi': "7508579432954383764",
            '__comet_req': "15",
            'lsd': self.lsd_token,
            'jazoest': self.jazoest,
            '__spin_r': "1023183597",
            '__spin_b': "trunk",
            '__spin_t': "1748227382",
            '__crn': "comet.fbweb.CometSinglePostDialogRoute",
            'fb_api_caller_class': "RelayModern",
            'fb_api_req_friendly_name': "CometUFIReactionIconTooltipContentQuery",
            'variables': f'{{"feedbackTargetID":"{self.feedback_target_id}","reactionID":"{reaction_id}"}}',
            'server_timestamps': "true",
            'doc_id': "9516958201714477"
        }
        
        api_headers = {
            'User-Agent': "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/136.0.0.0 Safari/537.36",
            'sec-ch-ua-full-version-list': '"Chromium";v="136.0.7103.114", "Google Chrome";v="136.0.7103.114", "Not.A/Brand";v="99.0.0.0"',
            'sec-ch-ua-platform': '"Windows"',
            'sec-ch-ua': '"Chromium";v="136", "Google Chrome";v="136", "Not.A/Brand";v="99"',
            'x-fb-friendly-name': "CometUFIReactionIconTooltipContentQuery",
            'sec-ch-ua-mobile': "?0",
            'sec-ch-ua-model': '""',
            'x-asbd-id': "359341",
            'x-fb-lsd': self.lsd_token,
            'sec-ch-prefers-color-scheme': "dark",
            'sec-ch-ua-platform-version': '"19.0.0"',
            'origin': "https://www.facebook.com",
            'sec-fetch-site': "same-origin",
            'sec-fetch-mode': "cors", 
            'sec-fetch-dest': "empty",
            'accept-language': "vi-VN,vi;q=0.9",
            'priority': "u=1, i"
        }
        
        response = self.session.post(api_url, data=payload, headers=api_headers)
        return response.text
    
    def _parse_reaction_response(self, response_text):
        try:
            data = json.loads(response_text)
            feedback_data = data.get('data', {}).get('feedback', {})
            reactors_data = feedback_data.get('reactors', {})
            
            total_count = reactors_data.get('count', 0)
            users = reactors_data.get('nodes', [])
            
            user_list = []
            for user in users:
                user_info = {
                    'id': user.get('id', ''),
                    'name': user.get('name', '')
                }
                user_list.append(user_info)
            
            return total_count, user_list
        except (json.JSONDecodeError, KeyError):
            return 0, []
    
    def analyze_reactions(self):
        if not self.feedback_target_id:
            print("Error: Could not extract feedback target ID from URL")
            return
        
        print(f"Feedback Target ID: {self.feedback_target_id}")
        print("-" * 50)
        
        print("Initializing tokens...")
        self._initialize_tokens()
        
        if not self.lsd_token or not self.jazoest:
            print("Error: Could not extract required tokens")
            return
        
        print("Tokens initialized successfully. Analyzing reactions...")
        print("-" * 50)
        
        for reaction_name, reaction_id in self.reactions.items():
            print(f"\n{reaction_name.upper()} REACTION:")
            print(f"Reaction ID: {reaction_id}")
            
            response_text = self._get_reaction_data(reaction_id)
            total_count, users = self._parse_reaction_response(response_text)
            
            print(f"Total {reaction_name} reactions: {total_count}")
            
            if users:
                print("Users who reacted:")
                for user in users:
                    print(f"  - ID: {user['id']}, Name: {user['name']}")
            else:
                print("No users found or no reactions of this type")
            
            print("-" * 30)
    

if __name__ == "__main__":
    url = "https://www.facebook.com/share/p/15cHBVkhrk/"
    analyzer = FacebookReactionAnalyzer(url)
    analyzer.analyze_reactions()